<!-- Copyright (C) 2017-2020 Linagora

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. -->

<div fxLayout="column" fxFlexFill class="wrapper-content">
  <div fxLayout="column" fxFlex class="content">
    <div *ngIf="container$ | async as container" fxLayout="column" fxLayoutGap="20px">

      <mat-card
        fxFlex
        class="padding-x0 card-container-reachabilities"
      >
        <div fxLayout="column" fxLayout.gt-md="row" fxFlexFill>
          <div
            fxLayout="column"
            [fxFlex.gt-md]="!container.isReachable ? '100' : '35'"
            class="container-infos"
            >
            <div class="title-about-wrapper">
              <mat-card-title class="light-bold title-about">About {{ container.name }}</mat-card-title>
            </div>

            <mat-card-content>
              <div fxLayout="column">
                <p fxLayout="column" class="margin-top-x1">
                  <span class="mat-body-2">IP or hostname</span>
                  <span class="container-ip">{{ container.ip }}</span>
                </p>
                <p fxLayout="column" class="margin-top-x1">
                  <span class="mat-body-2">Connection port</span>
                  <span class="container-port">{{ container.port }}</span>
                </p>
                <p *ngIf="container.isReachable" fxLayout="column" class="margin-top-x1">
                  <span class="mat-body-2">System Info</span>
                  <span class="container-system-info">{{ container.systemInfo }}</span>
                </p>

                <app-message
                  *ngIf="!!container.ip && !container.isReachable; else noContainerReachable"
                  type="warning"
                  msg="Unreachable"
                  [isClosable]="false"
                  class="warning-unreachable"
                ></app-message>

                <ng-template #noContainerReachable>
                  <app-message
                    *ngIf="!container.reachabilities.length"
                    type="info"
                    msg="There are no other containers in this bus."
                    [isClosable]="false"
                    class="info-no-container-reachable"
                  ></app-message>
                </ng-template>
              </div>
            </mat-card-content>
          </div>
          
          <div
            *ngIf="container.isReachable"
            fxLayout="column"
            fxFlex="none"
            fxFlex.gt-md="65"
            class="container-list-graph"
          >
            <div class="title-containers-wrapper">
              <mat-card-title class="light-bold title-containers">Container Reachabilities</mat-card-title>
            </div>

            <div
              *ngIf="container.isFetchingDetails; else displayContainerReachabilities"
              fxFlex
              fxLayout="column"
              fxLayoutAlign="center center"
              class="loading-graph padding-x2"
            >
              <mat-spinner [diameter]="64" [strokeWidth]="2" color="primary"></mat-spinner>
            </div>

            <ng-template #displayContainerReachabilities>
              <div
                fxFlex
                [visNetwork]="visNetwork"
                [visNetworkData]="visNetworkData"
                [visNetworkOptions]="visNetworkOptions"
                (initialized)="networkInitialized()"
                class="network-canvas"
              ></div>
            </ng-template>
          </div>
        </div>
      </mat-card>

      <app-artifacts-deployment
        [container]="container$ | async"
        [componentsByName]="componentsOfCurrentContainerByName$ | async"
        [sharedLibrariesByNameAndVersion]="sharedLibrariesOfCurrentContainerByNameAndVersion$ | async"
        [serviceAssembliesByName]="serviceAssembliesOfCurrentContainerByName$ | async"
      ></app-artifacts-deployment>
    </div>
  </div>
</div>
